#include "mysql.h"

MySql::MySql(QObject *parent) :
    QObject(parent)
{
}

MySql::~MySql(){
db.close();
}

/************************************************
**      
**
************************************************/



void MySql::setDatabaseName(QString name){
    MySql::sqlDatabaseName = name;
}


bool MySql::connect(){
    db = QSqlDatabase::addDatabase("QMYSQL");

    db.setHostName(MySql::sqlHostName);
    db.setDatabaseName(MySql::sqlDatabaseName);
    db.setUserName(MySql::sqlUserName);
    db.setPassword(MySql::sqlPassword);
    bool ok = db.open();
    if (ok) return true;
    else {
          MySql::mysqlLastError = db.lastError().text();
        return false; }

    /*
    pdb->setHostName(hostName);
    pdb->setDatabaseName(baseName);
    pdb->setUserName(userName);
    pdb->setPassword(password);
    bool ok = pdb->open();

if (!ok) {
                            QMessageBox::critical( //     .
                                                                            QWidget(this->parent()),                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            db.lastError().text());          //  .
                     }
  */

    return true;
}


void MySql::setUserName(QString uname){
    MySql::sqlUserName = uname;
}

void MySql::setPassword(QString passwrd){
    MySql::sqlPassword = passwrd;
}


void MySql::setHostName(QString hname){
    MySql::sqlHostName = hname;
}

bool  MySql::createTable(SqlTable* table){ //     
QSqlQuery q;
bool ok;
ok = q.prepare(table->sqlString());
if(!ok) {
    MySql::mysqlLastError = q.lastError().text();
    return false;}
ok = q.exec();
if(!ok) {
    MySql::mysqlLastError = q.lastError().text();
    return false;}
else return true;
}



QString MySql::lasError(){

    return MySql::mysqlLastError;
}



/************************************************
**       
**      
** ( ListOfClasses   DescriptionOfClasses)
************************************************/


bool MySql::createDataBase(){
    SqlTable* tbl;
    TableField* fld;
    if (!db.isOpen()){
        MySql::mysqlLastError = tr("Database is not open!");
        return false;
    }

    tbl = new SqlTable(tr("ListOfModels"));        //     ListOfModels     
    fld = new TableField(tr("ModelName"), tbl);    //        ,   ID      (   )
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New model"));          //    
    tbl->append(fld);                               //    


    fld = new TableField(tr("ModelString"), tbl);    //          
    fld->setType(tr("TEXT"));                        //   - 
    fld->setDefaultValue(tr("NULL"));                //    
    tbl->append(fld);

    fld = new TableField(tr("Enable"), tbl);    //          
    fld->setType(tr("BOOL"));                        //   - 
    fld->setDefaultValue(tr("1"));                //    
    tbl->append(fld);


    if(!MySql::createTable(tbl)){                   //     

   //     delete fld;
        delete tbl;                                 //   
        return false;                               //  
    }


    else {                                          //   
 //       delete fld;
        delete tbl;                                 //   
        return true;                                //   

    }





    tbl = new SqlTable(tr("ListOfClasses"));        //     ListOfClasses    
    fld = new TableField(tr("ClassName"), tbl);          //        ,   ID      (   )
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New class"));          //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("ClassAlias"), tbl);    //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New class alias"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("TableWhithInstance"), tbl);    //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New class instance"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("Comment"), tbl);    //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("without comments"));    //    
    tbl->append(fld);                               //    


    if(!MySql::createTable(tbl)){                   //     

   //     delete fld;
        delete tbl;                                 //   
        return false;                               //  
    }


    else {                                          //   
 //       delete fld;
        delete tbl;                                 //   
        return true;                                //   

    }

    tbl = new SqlTable(tr("DescriptionOfClasses")); //     DescriptionOfClassess     
    fld = new TableField(tr("FieldName"), tbl);     //        ,   ID      (   )
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New field"));          //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("FieldAlias"), tbl);    //         
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New class alias"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("FieldType"), tbl);     //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("CHAR(30)"));           //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("ClassIdentifer"), tbl);    //        
    fld->setNotNull(false);                          //     
    fld->setType(tr("INT(10)"));                   //   -  
    fld->setDefaultValue(tr("NULL"));    //    
    tbl->append(fld);                               //    



    fld = new TableField(tr("Comment"), tbl);    //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("without comments"));    //    
    tbl->append(fld);                               //    


    if(!MySql::createTable(tbl)){                   //     

   //     delete fld;
        delete tbl;                                 //   
        return false;                               //  
    }


    else {                                          //   
 //       delete fld;
        delete tbl;                                 //   
        return true;                                //   

    }





}




bool MySql::createListOfClassesTable(){

    SqlTable* tbl;
    TableField* fld;
    if (!db.isOpen()){
        MySql::mysqlLastError = tr("Database is not open!");
        return false;
    }
    tbl = new SqlTable(tr("ListOfClasses"));        //     ListOfClasses    
    fld = new TableField(tr("ClassName"), tbl);          //        ,   ID      (   )
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New class"));          //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("ClassAlias"), tbl);    //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New class alias"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("TableWhithInstance"), tbl);    //         -   
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New class instance"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("Comment"), tbl);    //       
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("without comments"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("Icon"), tbl);    //         
//    fld->setNotNull(true);                          //     
    fld->setType(tr("BLOB"));                   //   - "BLOB"
//    fld->setDefaultValue(tr("without comments"));    //    
    tbl->append(fld);                               //    




    if(!MySql::createTable(tbl)){                   //     

   //     delete fld;
        delete tbl;                                 //   
        return false;                               //  
    }


    else {                                          //   
 //       delete fld;
        delete tbl;                                 //   
        return true;                                //   

    }



}




bool MySql::createListModelsTable(){ //          ( ListOfModels)

    SqlTable* tbl;
    TableField* fld;
    if (!db.isOpen()){
        MySql::mysqlLastError = tr("Database is not open!");
        return false;
    }
    tbl = new SqlTable(tr("ListOfModels"));        //     ListOfModels    
    fld = new TableField(tr("ModelName"), tbl);    //        ,   ID      (   )
    //fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New model"));          //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("ModelString"), tbl);    //         
    //fld->setNotNull(true);                          //     
    fld->setType(tr("TEXT"));                   //   - 
    //fld->setDefaultValue(tr("New class alias"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("Enable"), tbl);    //    
    fld->setNotNull(true);                          //     
    fld->setType(tr("BOOL"));                   //   - 
    fld->setDefaultValue(tr("1"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("Comment"), tbl);    //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("without comments"));    //    
    tbl->append(fld);                               //    


    if(!MySql::createTable(tbl)){                   //     

   //     delete fld;
        delete tbl;                                 //   
        return false;                               //  
    }


    else {                                          //   
 //       delete fld;
        delete tbl;                                 //   
        return true;                                //   

    }


}

bool MySql::createDescriptionOfClassesTable(){ //           ( DescriptionOfClasses)
    SqlTable* tbl;
    TableField* fld;
    if (!db.isOpen()){
        MySql::mysqlLastError = tr("Database is not open!");
        return false;
    }
    tbl = new SqlTable(tr("DescriptionOfClasses")); //     DescriptionOfClassess     
    fld = new TableField(tr("FieldName"), tbl);     //        ,   ID      (   )
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New field"));          //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("FieldAlias"), tbl);    //         
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("New field alias"));    //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("FieldType"), tbl);     //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("CHAR(30)"));           //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("DefaultValue"), tbl);  //        
    fld->setNotNull(false);                         //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("NULL"));               //    
    tbl->append(fld);                               //    

    fld = new TableField(tr("ClassIdentifer"), tbl);    //        
    fld->setNotNull(false);                          //     
    fld->setType(tr("INT(10)"));                   //   -  
    fld->setDefaultValue(tr("NULL"));    //    
    tbl->append(fld);                               //    



    fld = new TableField(tr("Comment"), tbl);    //        
    fld->setNotNull(true);                          //     
    fld->setType(tr("CHAR(30)"));                   //   -   30 
    fld->setDefaultValue(tr("without comments"));    //    
    tbl->append(fld);                               //    


    if(!MySql::createTable(tbl)){                   //     

   //     delete fld;
        delete tbl;                                 //   
        return false;                               //  
    }


    else {                                          //   
 //       delete fld;
        delete tbl;                                 //   
        return true;                                //   

    }


}


QSqlError MySql::dbLastError(){ //      
    QString error;
    error = db.lastError().text();

    return db.lastError();
}


void MySql::close(){ //    
    db.close();

}
